> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.prolific.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.prolific.com/_mcp/server.

# Request a feedback upload URL

GET https://api.prolific.com/api/v1/submissions/signals/upload-url/{filename}

Request a temporary, pre-signed URL to upload a feedback file for your completed studies.

This is the first step of a two-step upload process:

1. Call this endpoint to receive a pre-signed `upload_url`.
2. Upload your file directly to that URL with an HTTP `PUT` request before it expires.

Supported file formats are CSV, XLS, XLSX, JSON, TXT and PDF. The maximum file size is 5GB. Please check the [supported file formats](/api-reference/submission-feedback-upload#supported-file-formats) section for more details.

Reference: https://docs.prolific.com/api-reference/submission-feedback-upload/get-submission-feedback-upload-url

## Authentication

- `Authorization` header (required) (prefixed with ` Token  `) — The Prolific API uses API token to authenticate requests. You can create an API token directly from your settings. Your API token does not have an expiry date and carries full permission, so be sure to keep them secure. If your token is leaked, delete it and create a new one directly in the app. In your requests add `Authorization` header with the value `Token <your token>`.

## Request

### Path parameters

- `filename` (string, required) — The name of the file you want to upload, including its extension (e.g. `participant_feedback.csv`).

### Query parameters

- `workspace_id` (string, required) — The ID of the Prolific workspace the feedback belongs to.

## Response

### 201

Pre-signed upload URL generated successfully.

- `upload_url` (string, optional) — The temporary, pre-signed URL to upload your file to with an HTTP `PUT` request.
- `http_method` (enum, optional) — The HTTP method to use when uploading to `upload_url`.
  - Allowed values: `PUT`
- `expires_at` (datetime, optional) — The time at which the pre-signed `upload_url` expires.

## Errors

### 400 Client Request Error

Error

- `error` (ErrorDetail, required)

## Types

### ErrorDetail

- `status` (integer, required) — Status code as in the http standards
- `error_code` (integer, required) — Internal error code
- `title` (string, required) — Error title
- `detail` (ErrorDetailDetail, required) — Error detail
- `additional_information` (string, optional) — Optional extra information
- `traceback` (string, optional) — Optional debug information
- `interactive` (boolean, optional)

### ErrorDetailDetail

Error detail

### ErrorDetailDetail2

All fields with validation errors

- `any_field` (list of string, optional) — Name of the field with a validation error and as a value an array with the error descriptions

## Examples

**Response**

```json
{
  "upload_url": "https://submission-signals.s3.amazonaws.com/study123_feedback.csv?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=...",
  "http_method": "PUT",
  "expires_at": "2025-05-15T11:11:14.321Z"
}
```

**SDK Code**

```python
import requests

url = "https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv"

querystring = {"workspace_id":"6278acb09062db3b35bcb123"}

headers = {"Authorization": "Token <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123';
const options = {method: 'GET', headers: {Authorization: 'Token <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Token <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Token <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123")
  .header("Authorization", "Token <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123', [
  'headers' => [
    'Authorization' => 'Token <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Token <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Token <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.prolific.com/api/v1/submissions/signals/upload-url/participant_feedback.csv?workspace_id=6278acb09062db3b35bcb123")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```